diff -r 0e86e50bebeb -r eea535071231 libinterp/corefcn/graphics.cc
--- a/libinterp/corefcn/graphics.cc	Sun Oct 25 19:28:08 2020 -0700
+++ b/libinterp/corefcn/graphics.cc	Tue Nov 10 00:52:22 2020 +0100
@@ -51,6 +51,7 @@
 #include "defun.h"
 #include "display.h"
 #include "error.h"
+#include "event-manager.h"
 #include "graphics.h"
 #include "input.h"
 #include "interpreter-private.h"
@@ -1261,13 +1262,17 @@ base_property::set (const octave_value& 
 {
   if (do_set (v))
     {
+      gh_manager& gh_mgr
+        = octave::__get_gh_manager__ ("base_property::set");
+
+      octave::event_manager& ev_mgr
+        = octave::__get_event_manager__ ("base_property::set");
+
+      graphics_object go = gh_mgr.get_object (parent);
+
       // Notify graphics toolkit.
       if (id >= 0 && do_notify_toolkit)
         {
-          gh_manager& gh_mgr
-            = octave::__get_gh_manager__ ("base_property::set");
-
-          graphics_object go = gh_mgr.get_object (parent);
           if (go)
             go.update (id);
         }
@@ -1276,6 +1281,9 @@ base_property::set (const octave_value& 
       if (do_run)
         run_listeners (GCB_POSTSET);
 
+      // notify gui of the property change
+      ev_mgr.notify_go_updated(go, id);
+
       return true;
     }
 
@@ -2858,6 +2866,9 @@ gh_manager::free (const graphics_handle&
       if (p == m_handle_map.end ())
         error ("graphics_handle::free: invalid object %g", h.value ());
 
+      // Notify the event-manager
+      m_interpreter.get_event_manager ().notify_go_will_delete (p->second);
+
       base_properties& bp = p->second.get_properties ();
 
       if (! p->second.valid_object () || bp.is_beingdeleted ())
@@ -2912,6 +2923,8 @@ void
 gh_manager::renumber_figure (const graphics_handle& old_gh,
                              const graphics_handle& new_gh)
 {
+  // FIXME: do we have to notify the event manager?
+
   auto p = m_handle_map.find (old_gh);
 
   if (p == m_handle_map.end ())
@@ -2919,10 +2932,14 @@ gh_manager::renumber_figure (const graph
 
   graphics_object go = p->second;
 
+  // m_interpreter.get_event_manager().notify_go_will_delete(go);
+
   m_handle_map.erase (p);
 
   m_handle_map[new_gh] = go;
 
+  // m_interpreter.get_event_manager().notify_go_created(go);
+
   if (old_gh.value () < 0)
     m_handle_free_list.insert (std::ceil (old_gh.value ())
                                - make_handle_fraction ());
@@ -11888,6 +11905,9 @@ gh_manager::make_graphics_handle (const 
   if (notify_toolkit)
     go.initialize ();
 
+  // Notify the event manager
+  m_interpreter.get_event_manager().notify_go_created(go);
+
   return h;
 }
 
@@ -11905,6 +11925,9 @@ gh_manager::make_figure_handle (double v
   if (notify_toolkit)
     go.initialize ();
 
+  // Notify the event manager
+  m_interpreter.get_event_manager().notify_go_created(go);
+
   go.override_defaults ();
 
   return h;
diff -r 0e86e50bebeb -r eea535071231 libinterp/corefcn/graphics.in.h
--- a/libinterp/corefcn/graphics.in.h	Sun Oct 25 19:28:08 2020 -0700
+++ b/libinterp/corefcn/graphics.in.h	Tue Nov 10 00:52:22 2020 +0100
@@ -60,6 +60,25 @@
 
 // ---------------------------------------------------------------------
 
+enum class property_type
+{
+  INVALID,
+  ARRAY,
+  BOOL,
+  CALLBACK,
+  CHILDREN,
+  COLOR,
+  DOUBLE,
+  DOUBLE_RADIO,
+  HANDLE,
+  RADIO,
+  ROW_VECTOR,
+  STRING,
+  STRING_ARRAY,
+  TEXT_LABEL,
+  ANY,
+};
+
 class base_scaler
 {
 public:
@@ -314,6 +333,8 @@ public:
 
   virtual bool is_radio (void) const { return false; }
 
+  virtual property_type prop_type () const { return property_type::INVALID; }
+
   int get_id (void) const { return id; }
 
   void set_id (int d) { id = d; }
@@ -440,6 +461,11 @@ public:
   string_property (const string_property& p)
     : base_property (p), str (p.str) { }
 
+  virtual property_type prop_type () const override
+  {
+    return property_type::STRING;
+  }
+
   octave_value get (void) const
   { return octave_value (str); }
 
@@ -525,6 +551,11 @@ public:
     : base_property (p), desired_type (p.desired_type),
       separator (p.separator), str (p.str) { }
 
+  virtual property_type prop_type () const override
+  {
+    return property_type::STRING_ARRAY;
+  }
+
   octave_value get (void) const
   {
     if (desired_type == string_t)
@@ -737,6 +768,11 @@ public:
     return tmp.isempty ();
   }
 
+  virtual property_type prop_type () const override
+  {
+    return property_type::TEXT_LABEL;
+  }
+
   octave_value get (void) const
   {
     if (stored_type == char_t)
@@ -941,6 +977,11 @@ public:
   radio_property (const radio_property& p)
     : base_property (p), vals (p.vals), current_val (p.current_val) { }
 
+  virtual property_type prop_type () const override
+  {
+    return property_type::RADIO;
+  }
+
   octave_value get (void) const { return octave_value (current_val); }
 
   const std::string& current_value (void) const { return current_val; }
@@ -1107,6 +1148,11 @@ public:
       color_val (p.color_val), radio_val (p.radio_val),
       current_val (p.current_val) { }
 
+  virtual property_type prop_type () const override
+  {
+    return property_type::COLOR;
+  }
+
   octave_value get (void) const
   {
     if (current_type == color_t)
@@ -1188,6 +1234,11 @@ public:
       minval (std::pair<double, bool> (octave_NaN, true)),
       maxval (std::pair<double, bool> (octave_NaN, true)) { }
 
+  virtual property_type prop_type () const override
+  {
+    return property_type::DOUBLE;
+  }
+
   octave_value get (void) const { return octave_value (current_val); }
 
   double double_value (void) const { return current_val; }
@@ -1312,6 +1363,11 @@ public:
       dval (p.dval), radio_val (p.radio_val),
       current_val (p.current_val) { }
 
+  virtual property_type prop_type () const override
+  {
+    return property_type::DOUBLE_RADIO;
+  }
+
   octave_value get (void) const
   {
     if (current_type == double_t)
@@ -1401,6 +1457,11 @@ public:
       maxval (std::pair<double, bool> (octave_NaN, true))
   { }
 
+  virtual property_type prop_type () const override
+  {
+    return property_type::ARRAY;
+  }
+
   octave_value get (void) const { return data; }
 
   void add_constraint (const std::string& type)
@@ -1517,6 +1578,11 @@ public:
     add_constraint (dim_vector (0, 0));
   }
 
+  virtual property_type prop_type () const override
+  {
+    return property_type::ROW_VECTOR;
+  }
+
   void add_constraint (const std::string& type)
   {
     array_property::add_constraint (type);
@@ -1608,6 +1674,11 @@ public:
   bool_property (const bool_property& p)
     : radio_property (p) { }
 
+  virtual property_type prop_type () const override
+  {
+    return property_type::BOOL;
+  }
+
   bool is_on (void) const { return is ("on"); }
 
   bool_property& operator = (const octave_value& val)
@@ -1641,6 +1712,11 @@ public:
   handle_property (const handle_property& p)
     : base_property (p), current_val (p.current_val) { }
 
+  virtual property_type prop_type () const override
+  {
+    return property_type::HANDLE;
+  }
+
   octave_value get (void) const { return current_val.as_octave_value (); }
 
   graphics_handle handle_value (void) const { return current_val; }
@@ -1693,6 +1769,8 @@ public:
     return *this;
   }
 
+  virtual property_type prop_type () const override { return property_type::ANY; }
+
   base_property * clone (void) const { return new any_property (*this); }
 
 protected:
@@ -1730,6 +1808,11 @@ public:
     do_init_children (p.children_list);
   }
 
+  virtual property_type prop_type () const override
+  {
+    return property_type::CHILDREN;
+  }
+
   children_property& operator = (const octave_value& val)
   {
     set (val);
@@ -1909,6 +1992,11 @@ public:
   callback_property (const callback_property& p)
     : base_property (p), callback (p.callback) { }
 
+  virtual property_type prop_type () const override
+  {
+    return property_type::CALLBACK;
+  }
+
   octave_value get (void) const { return callback; }
 
   OCTINTERP_API void execute (const octave_value& data = octave_value ()) const;
@@ -1947,6 +2035,24 @@ private:
 
 // ---------------------------------------------------------------------
 
+#if 0
+
+namespace detail {
+
+template<class prop_type>
+inline prop_type& prop_cast(base_property *rep, const char *who)
+{
+  auto *p = dynamic_cast<prop_type*>(rep);
+  if (!p) {
+    throw std::logic_error(std::string(who) + ": invalid property cast");
+  }
+  return *p;
+}
+
+}
+
+#endif // 0
+
 class property
 {
 public:
@@ -2037,6 +2143,11 @@ public:
   void run_listeners (listener_mode mode = GCB_POSTSET)
   { rep->run_listeners (mode); }
 
+  property_type prop_type() const
+  {
+    return rep->prop_type();
+  }
+
   OCTINTERP_API static
   property create (const std::string& name, const graphics_handle& parent,
                    const caseless_str& type,
@@ -2045,25 +2156,180 @@ public:
   property clone (void) const
   { return property (rep->clone ()); }
 
+  const base_property& as_base_property (void) const { return *rep; }
+
+  base_property& as_base_property (void) { return *rep; }
+
 #if 0
-  const string_property& as_string_property (void) const
-  { return *(dynamic_cast<string_property *> (rep)); }
-
-  const radio_property& as_radio_property (void) const
-  { return *(dynamic_cast<radio_property *> (rep)); }
+
+  const array_property& as_array_property (void) const
+  {
+    return detail::prop_cast<const array_property> (
+        rep, "property::as_array_property");
+  }
+
+  array_property& as_array_property (void)
+  {
+    return detail::prop_cast<array_property> (rep,
+                                              "property::as_array_property");
+  }
+
+  const bool_property& as_bool_property (void) const
+  {
+    return detail::prop_cast<const bool_property> (
+        rep, "property::as_bool_property");
+  }
+
+  bool_property& as_bool_property (void)
+  {
+    return detail::prop_cast<bool_property> (rep,
+                                             "property::as_bool_property");
+  }
+
+  const callback_property& as_callback_property (void) const
+  {
+    return detail::prop_cast<const callback_property> (
+        rep, "property::as_callback_property");
+  }
+
+  callback_property& as_callback_property (void)
+  {
+    return detail::prop_cast<callback_property> (
+        rep, "property::as_callback_property");
+  }
+
+  const children_property& as_children_property (void) const
+  {
+    return detail::prop_cast<const children_property> (
+        rep, "property::as_children_property");
+  }
+
+  children_property& as_children_property (void)
+  {
+    return detail::prop_cast<children_property> (
+        rep, "property::as_children_property");
+  }
 
   const color_property& as_color_property (void) const
-  { return *(dynamic_cast<color_property *> (rep)); }
+  {
+    return detail::prop_cast<const color_property> (
+        rep, "property::as_color_property");
+  }
+
+  color_property& as_color_property (void)
+  {
+    return detail::prop_cast<color_property> (rep,
+                                              "property::as_color_property");
+  }
 
   const double_property& as_double_property (void) const
-  { return *(dynamic_cast<double_property *> (rep)); }
-
-  const bool_property& as_bool_property (void) const
-  { return *(dynamic_cast<bool_property *> (rep)); }
+  {
+    return detail::prop_cast<const double_property> (
+        rep, "property::as_double_property");
+  }
+
+  double_property& as_double_property (void)
+  {
+    return detail::prop_cast<double_property> (rep,
+                                               "property::as_double_property");
+  }
+
+  const double_radio_property& as_double_radio_property (void) const
+  {
+    return detail::prop_cast<const double_radio_property> (
+        rep, "property::as_double_radio_property");
+  }
+
+  double_radio_property& as_double_radio_property (void)
+  {
+    return detail::prop_cast<double_radio_property> (
+        rep, "property::as_double_radio_property");
+  }
 
   const handle_property& as_handle_property (void) const
-  { return *(dynamic_cast<handle_property *> (rep)); }
-#endif
+  {
+    return detail::prop_cast<const handle_property> (
+        rep, "property::as_handle_property");
+  }
+
+  handle_property& as_handle_property (void)
+  {
+    return detail::prop_cast<handle_property> (rep,
+                                               "property::as_handle_property");
+  }
+
+  const radio_property& as_radio_property (void) const
+  {
+    return detail::prop_cast<const radio_property> (
+        rep, "property::as_radio_property");
+  }
+
+  radio_property& as_radio_property (void)
+  {
+    return detail::prop_cast<radio_property> (rep,
+                                              "property::as_radio_property");
+  }
+
+  const row_vector_property& as_row_vector_property (void) const
+  {
+    return detail::prop_cast<const row_vector_property> (
+        rep, "property::as_row_vector_property");
+  }
+
+  row_vector_property& as_row_vector_property (void)
+  {
+    return detail::prop_cast<row_vector_property> (
+        rep, "property::as_row_vector_property");
+  }
+
+  const string_property& as_string_property (void) const
+  {
+    return detail::prop_cast<const string_property> (
+        rep, "property::as_string_property");
+  }
+
+  string_property& as_string_property (void)
+  {
+    return detail::prop_cast<string_property> (rep,
+                                               "property::as_string_property");
+  }
+
+  const string_array_property& as_string_array_property (void) const
+  {
+    return detail::prop_cast<const string_array_property> (
+        rep, "property::as_string_array_property");
+  }
+
+  string_array_property& as_string_array_property (void)
+  {
+    return detail::prop_cast<string_array_property> (
+        rep, "property::as_string_array_property");
+  }
+
+  const text_label_property& as_text_label_property (void) const
+  {
+    return detail::prop_cast<const text_label_property> (
+        rep, "property::as_text_label_property");
+  }
+
+  text_label_property& as_text_label_property (void)
+  {
+    return detail::prop_cast<text_label_property> (
+        rep, "property::as_text_label_property");
+  }
+
+  const any_property& as_any_property (void) const
+  {
+    return detail::prop_cast<const any_property> (rep,
+                                                  "property::as_any_property");
+  }
+
+  any_property& as_any_property (void)
+  {
+    return detail::prop_cast<any_property> (rep, "property::as_any_property");
+  }
+
+#endif // 0
 
 private:
   base_property *rep;
@@ -6728,4 +6994,21 @@ OCTINTERP_API graphics_handle gca (void)
 
 OCTINTERP_API void close_all_figures (void);
 
+// property introspection system
+
+struct graphics_property_info
+{
+  std::string name;
+  int id;
+  property_type type;
+};
+
+struct graphics_handle_type_info
+{
+  std::string type;
+  std::vector<graphics_property_info> static_prop_info;
+};
+
+
+
 #endif
diff -r 0e86e50bebeb -r eea535071231 liboctave/util/oct-mutex.h
--- a/liboctave/util/oct-mutex.h	Sun Oct 25 19:28:08 2020 -0700
+++ b/liboctave/util/oct-mutex.h	Tue Nov 10 00:52:22 2020 +0100
@@ -26,6 +26,8 @@
 #if ! defined (octave_oct_mutex_h)
 #define octave_oct_mutex_h 1
 
+#include <stdexcept>
+
 #include "octave-config.h"
 
 #include "oct-refcount.h"
@@ -145,6 +147,48 @@ namespace octave
     bool m_lock_result;
   };
 
+  // a moveable, non-copiable lock that acts like a smart pointer
+  // the type must implement lock and unlock. (it also work with plain mutex)
+  template <class T>
+  class unique_lock
+  {
+  public:
+
+    // may be holding a ref is better
+    unique_lock (T& r) : rep (r), owned (true) { rep.lock (); }
+
+    ~unique_lock ()
+    {
+      if (owned)
+        rep.unlock ();
+    }
+
+    unique_lock (const unique_lock&) = delete;
+    unique_lock& operator= (const unique_lock&) = delete;
+
+    unique_lock (unique_lock&& other) : rep (other.rep), owned (other.owned)
+    {
+      other.owned = false;
+    }
+
+    T* operator->()
+    {
+      if (!owned)
+        throw std::logic_error { "access of non-owned locked resource" };
+      return &rep;
+    }
+
+    T& operator* ()
+    {
+      if (!owned)
+        throw std::logic_error { "access of non-owned locked resource" };
+      return rep;
+    }
+
+  private:
+    T& rep;
+    bool owned;
+  };
 
   class
   OCTAVE_API
